########## R function: generExampData ##########

# For generation of example generalized linear mixed 
# model data.

# Last changed: 22 OCT 2020

generExampData <- function(m,nVec,Xdistn,beta0True,betaBTrue,sigsqTrue,family,seed=1)
{
   # Set the seed:

   set.seed(seed)

   # Generate data:

   dB <- length(betaBTrue)
   Uvec <- rnorm(m,0,sqrt(sigsqTrue))
   y <- NULL ; XB <- NULL ; idNum <- NULL
   for (i in 1:m)
   {
      if (Xdistn=="norm") XBcurr <- matrix(rnorm(dB*nVec[i]),nVec[i],dB)   
      if (Xdistn=="unif") XBcurr <- matrix(runif(dB*nVec[i],-1,1),nVec[i],dB)
      if (family=="binomial")
      {
         muCurr <- plogis(beta0True + as.vector(XBcurr%*%betaBTrue) + Uvec[i])
         yCurr <- rbinom(nVec[i],1,muCurr)
      }
      if (family=="poisson")
      {
         muCurr <- exp(beta0True + as.vector(XBcurr%*%betaBTrue) + Uvec[i])
         yCurr <- rpois(nVec[i],muCurr)
      }
      XB <- rbind(XB,XBcurr) 
      y <- c(y,yCurr)
      idNum <- c(idNum,rep(i,nVec[i]))
   }

   # Return the generated data as a list:

   return(list(y=y,idNum=idNum,XB=XB))
}

############ End of generExampData ############
